import React__default, { useRef, useEffect, useCallback, useState } from 'react';

function _objectWithoutPropertiesLoose(source, excluded) {
  if (source == null) return {};
  var target = {};
  var sourceKeys = Object.keys(source);
  var key, i;

  for (i = 0; i < sourceKeys.length; i++) {
    key = sourceKeys[i];
    if (excluded.indexOf(key) >= 0) continue;
    target[key] = source[key];
  }

  return target;
}

function _unsupportedIterableToArray(o, minLen) {
  if (!o) return;
  if (typeof o === "string") return _arrayLikeToArray(o, minLen);
  var n = Object.prototype.toString.call(o).slice(8, -1);
  if (n === "Object" && o.constructor) n = o.constructor.name;
  if (n === "Map" || n === "Set") return Array.from(o);
  if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen);
}

function _arrayLikeToArray(arr, len) {
  if (len == null || len > arr.length) len = arr.length;

  for (var i = 0, arr2 = new Array(len); i < len; i++) arr2[i] = arr[i];

  return arr2;
}

function _createForOfIteratorHelperLoose(o, allowArrayLike) {
  var it;

  if (typeof Symbol === "undefined" || o[Symbol.iterator] == null) {
    if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") {
      if (it) o = it;
      var i = 0;
      return function () {
        if (i >= o.length) return {
          done: true
        };
        return {
          done: false,
          value: o[i++]
        };
      };
    }

    throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
  }

  it = o[Symbol.iterator]();
  return it.next.bind(it);
}

function createCommonjsModule(fn, module) {
	return module = { exports: {} }, fn(module, module.exports), module.exports;
}

/** @license React v16.13.1
 * react-is.production.min.js
 *
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */
var b="function"===typeof Symbol&&Symbol.for,c=b?Symbol.for("react.element"):60103,d=b?Symbol.for("react.portal"):60106,e=b?Symbol.for("react.fragment"):60107,f=b?Symbol.for("react.strict_mode"):60108,g=b?Symbol.for("react.profiler"):60114,h=b?Symbol.for("react.provider"):60109,k=b?Symbol.for("react.context"):60110,l=b?Symbol.for("react.async_mode"):60111,m=b?Symbol.for("react.concurrent_mode"):60111,n=b?Symbol.for("react.forward_ref"):60112,p=b?Symbol.for("react.suspense"):60113,q=b?
Symbol.for("react.suspense_list"):60120,r=b?Symbol.for("react.memo"):60115,t=b?Symbol.for("react.lazy"):60116,v=b?Symbol.for("react.block"):60121,w=b?Symbol.for("react.fundamental"):60117,x=b?Symbol.for("react.responder"):60118,y=b?Symbol.for("react.scope"):60119;
function z(a){if("object"===typeof a&&null!==a){var u=a.$$typeof;switch(u){case c:switch(a=a.type,a){case l:case m:case e:case g:case f:case p:return a;default:switch(a=a&&a.$$typeof,a){case k:case n:case t:case r:case h:return a;default:return u}}case d:return u}}}function A(a){return z(a)===m}var AsyncMode=l;var ConcurrentMode=m;var ContextConsumer=k;var ContextProvider=h;var Element=c;var ForwardRef=n;var Fragment=e;var Lazy=t;var Memo=r;var Portal=d;
var Profiler=g;var StrictMode=f;var Suspense=p;var isAsyncMode=function(a){return A(a)||z(a)===l};var isConcurrentMode=A;var isContextConsumer=function(a){return z(a)===k};var isContextProvider=function(a){return z(a)===h};var isElement=function(a){return "object"===typeof a&&null!==a&&a.$$typeof===c};var isForwardRef=function(a){return z(a)===n};var isFragment=function(a){return z(a)===e};var isLazy=function(a){return z(a)===t};
var isMemo=function(a){return z(a)===r};var isPortal=function(a){return z(a)===d};var isProfiler=function(a){return z(a)===g};var isStrictMode=function(a){return z(a)===f};var isSuspense=function(a){return z(a)===p};
var isValidElementType=function(a){return "string"===typeof a||"function"===typeof a||a===e||a===m||a===g||a===f||a===p||a===q||"object"===typeof a&&null!==a&&(a.$$typeof===t||a.$$typeof===r||a.$$typeof===h||a.$$typeof===k||a.$$typeof===n||a.$$typeof===w||a.$$typeof===x||a.$$typeof===y||a.$$typeof===v)};var typeOf=z;

var reactIs_production_min = {
	AsyncMode: AsyncMode,
	ConcurrentMode: ConcurrentMode,
	ContextConsumer: ContextConsumer,
	ContextProvider: ContextProvider,
	Element: Element,
	ForwardRef: ForwardRef,
	Fragment: Fragment,
	Lazy: Lazy,
	Memo: Memo,
	Portal: Portal,
	Profiler: Profiler,
	StrictMode: StrictMode,
	Suspense: Suspense,
	isAsyncMode: isAsyncMode,
	isConcurrentMode: isConcurrentMode,
	isContextConsumer: isContextConsumer,
	isContextProvider: isContextProvider,
	isElement: isElement,
	isForwardRef: isForwardRef,
	isFragment: isFragment,
	isLazy: isLazy,
	isMemo: isMemo,
	isPortal: isPortal,
	isProfiler: isProfiler,
	isStrictMode: isStrictMode,
	isSuspense: isSuspense,
	isValidElementType: isValidElementType,
	typeOf: typeOf
};

var reactIs_development = createCommonjsModule(function (module, exports) {



if (process.env.NODE_ENV !== "production") {
  (function() {

// The Symbol used to tag the ReactElement-like types. If there is no native Symbol
// nor polyfill, then a plain number is used for performance.
var hasSymbol = typeof Symbol === 'function' && Symbol.for;
var REACT_ELEMENT_TYPE = hasSymbol ? Symbol.for('react.element') : 0xeac7;
var REACT_PORTAL_TYPE = hasSymbol ? Symbol.for('react.portal') : 0xeaca;
var REACT_FRAGMENT_TYPE = hasSymbol ? Symbol.for('react.fragment') : 0xeacb;
var REACT_STRICT_MODE_TYPE = hasSymbol ? Symbol.for('react.strict_mode') : 0xeacc;
var REACT_PROFILER_TYPE = hasSymbol ? Symbol.for('react.profiler') : 0xead2;
var REACT_PROVIDER_TYPE = hasSymbol ? Symbol.for('react.provider') : 0xeacd;
var REACT_CONTEXT_TYPE = hasSymbol ? Symbol.for('react.context') : 0xeace; // TODO: We don't use AsyncMode or ConcurrentMode anymore. They were temporary
// (unstable) APIs that have been removed. Can we remove the symbols?

var REACT_ASYNC_MODE_TYPE = hasSymbol ? Symbol.for('react.async_mode') : 0xeacf;
var REACT_CONCURRENT_MODE_TYPE = hasSymbol ? Symbol.for('react.concurrent_mode') : 0xeacf;
var REACT_FORWARD_REF_TYPE = hasSymbol ? Symbol.for('react.forward_ref') : 0xead0;
var REACT_SUSPENSE_TYPE = hasSymbol ? Symbol.for('react.suspense') : 0xead1;
var REACT_SUSPENSE_LIST_TYPE = hasSymbol ? Symbol.for('react.suspense_list') : 0xead8;
var REACT_MEMO_TYPE = hasSymbol ? Symbol.for('react.memo') : 0xead3;
var REACT_LAZY_TYPE = hasSymbol ? Symbol.for('react.lazy') : 0xead4;
var REACT_BLOCK_TYPE = hasSymbol ? Symbol.for('react.block') : 0xead9;
var REACT_FUNDAMENTAL_TYPE = hasSymbol ? Symbol.for('react.fundamental') : 0xead5;
var REACT_RESPONDER_TYPE = hasSymbol ? Symbol.for('react.responder') : 0xead6;
var REACT_SCOPE_TYPE = hasSymbol ? Symbol.for('react.scope') : 0xead7;

function isValidElementType(type) {
  return typeof type === 'string' || typeof type === 'function' || // Note: its typeof might be other than 'symbol' or 'number' if it's a polyfill.
  type === REACT_FRAGMENT_TYPE || type === REACT_CONCURRENT_MODE_TYPE || type === REACT_PROFILER_TYPE || type === REACT_STRICT_MODE_TYPE || type === REACT_SUSPENSE_TYPE || type === REACT_SUSPENSE_LIST_TYPE || typeof type === 'object' && type !== null && (type.$$typeof === REACT_LAZY_TYPE || type.$$typeof === REACT_MEMO_TYPE || type.$$typeof === REACT_PROVIDER_TYPE || type.$$typeof === REACT_CONTEXT_TYPE || type.$$typeof === REACT_FORWARD_REF_TYPE || type.$$typeof === REACT_FUNDAMENTAL_TYPE || type.$$typeof === REACT_RESPONDER_TYPE || type.$$typeof === REACT_SCOPE_TYPE || type.$$typeof === REACT_BLOCK_TYPE);
}

function typeOf(object) {
  if (typeof object === 'object' && object !== null) {
    var $$typeof = object.$$typeof;

    switch ($$typeof) {
      case REACT_ELEMENT_TYPE:
        var type = object.type;

        switch (type) {
          case REACT_ASYNC_MODE_TYPE:
          case REACT_CONCURRENT_MODE_TYPE:
          case REACT_FRAGMENT_TYPE:
          case REACT_PROFILER_TYPE:
          case REACT_STRICT_MODE_TYPE:
          case REACT_SUSPENSE_TYPE:
            return type;

          default:
            var $$typeofType = type && type.$$typeof;

            switch ($$typeofType) {
              case REACT_CONTEXT_TYPE:
              case REACT_FORWARD_REF_TYPE:
              case REACT_LAZY_TYPE:
              case REACT_MEMO_TYPE:
              case REACT_PROVIDER_TYPE:
                return $$typeofType;

              default:
                return $$typeof;
            }

        }

      case REACT_PORTAL_TYPE:
        return $$typeof;
    }
  }

  return undefined;
} // AsyncMode is deprecated along with isAsyncMode

var AsyncMode = REACT_ASYNC_MODE_TYPE;
var ConcurrentMode = REACT_CONCURRENT_MODE_TYPE;
var ContextConsumer = REACT_CONTEXT_TYPE;
var ContextProvider = REACT_PROVIDER_TYPE;
var Element = REACT_ELEMENT_TYPE;
var ForwardRef = REACT_FORWARD_REF_TYPE;
var Fragment = REACT_FRAGMENT_TYPE;
var Lazy = REACT_LAZY_TYPE;
var Memo = REACT_MEMO_TYPE;
var Portal = REACT_PORTAL_TYPE;
var Profiler = REACT_PROFILER_TYPE;
var StrictMode = REACT_STRICT_MODE_TYPE;
var Suspense = REACT_SUSPENSE_TYPE;
var hasWarnedAboutDeprecatedIsAsyncMode = false; // AsyncMode should be deprecated

function isAsyncMode(object) {
  {
    if (!hasWarnedAboutDeprecatedIsAsyncMode) {
      hasWarnedAboutDeprecatedIsAsyncMode = true; // Using console['warn'] to evade Babel and ESLint

      console['warn']('The ReactIs.isAsyncMode() alias has been deprecated, ' + 'and will be removed in React 17+. Update your code to use ' + 'ReactIs.isConcurrentMode() instead. It has the exact same API.');
    }
  }

  return isConcurrentMode(object) || typeOf(object) === REACT_ASYNC_MODE_TYPE;
}
function isConcurrentMode(object) {
  return typeOf(object) === REACT_CONCURRENT_MODE_TYPE;
}
function isContextConsumer(object) {
  return typeOf(object) === REACT_CONTEXT_TYPE;
}
function isContextProvider(object) {
  return typeOf(object) === REACT_PROVIDER_TYPE;
}
function isElement(object) {
  return typeof object === 'object' && object !== null && object.$$typeof === REACT_ELEMENT_TYPE;
}
function isForwardRef(object) {
  return typeOf(object) === REACT_FORWARD_REF_TYPE;
}
function isFragment(object) {
  return typeOf(object) === REACT_FRAGMENT_TYPE;
}
function isLazy(object) {
  return typeOf(object) === REACT_LAZY_TYPE;
}
function isMemo(object) {
  return typeOf(object) === REACT_MEMO_TYPE;
}
function isPortal(object) {
  return typeOf(object) === REACT_PORTAL_TYPE;
}
function isProfiler(object) {
  return typeOf(object) === REACT_PROFILER_TYPE;
}
function isStrictMode(object) {
  return typeOf(object) === REACT_STRICT_MODE_TYPE;
}
function isSuspense(object) {
  return typeOf(object) === REACT_SUSPENSE_TYPE;
}

exports.AsyncMode = AsyncMode;
exports.ConcurrentMode = ConcurrentMode;
exports.ContextConsumer = ContextConsumer;
exports.ContextProvider = ContextProvider;
exports.Element = Element;
exports.ForwardRef = ForwardRef;
exports.Fragment = Fragment;
exports.Lazy = Lazy;
exports.Memo = Memo;
exports.Portal = Portal;
exports.Profiler = Profiler;
exports.StrictMode = StrictMode;
exports.Suspense = Suspense;
exports.isAsyncMode = isAsyncMode;
exports.isConcurrentMode = isConcurrentMode;
exports.isContextConsumer = isContextConsumer;
exports.isContextProvider = isContextProvider;
exports.isElement = isElement;
exports.isForwardRef = isForwardRef;
exports.isFragment = isFragment;
exports.isLazy = isLazy;
exports.isMemo = isMemo;
exports.isPortal = isPortal;
exports.isProfiler = isProfiler;
exports.isStrictMode = isStrictMode;
exports.isSuspense = isSuspense;
exports.isValidElementType = isValidElementType;
exports.typeOf = typeOf;
  })();
}
});

var reactIs = createCommonjsModule(function (module) {

if (process.env.NODE_ENV === 'production') {
  module.exports = reactIs_production_min;
} else {
  module.exports = reactIs_development;
}
});

/*
object-assign
(c) Sindre Sorhus
@license MIT
*/
/* eslint-disable no-unused-vars */
var getOwnPropertySymbols = Object.getOwnPropertySymbols;
var hasOwnProperty = Object.prototype.hasOwnProperty;
var propIsEnumerable = Object.prototype.propertyIsEnumerable;

function toObject(val) {
	if (val === null || val === undefined) {
		throw new TypeError('Object.assign cannot be called with null or undefined');
	}

	return Object(val);
}

function shouldUseNative() {
	try {
		if (!Object.assign) {
			return false;
		}

		// Detect buggy property enumeration order in older V8 versions.

		// https://bugs.chromium.org/p/v8/issues/detail?id=4118
		var test1 = new String('abc');  // eslint-disable-line no-new-wrappers
		test1[5] = 'de';
		if (Object.getOwnPropertyNames(test1)[0] === '5') {
			return false;
		}

		// https://bugs.chromium.org/p/v8/issues/detail?id=3056
		var test2 = {};
		for (var i = 0; i < 10; i++) {
			test2['_' + String.fromCharCode(i)] = i;
		}
		var order2 = Object.getOwnPropertyNames(test2).map(function (n) {
			return test2[n];
		});
		if (order2.join('') !== '0123456789') {
			return false;
		}

		// https://bugs.chromium.org/p/v8/issues/detail?id=3056
		var test3 = {};
		'abcdefghijklmnopqrst'.split('').forEach(function (letter) {
			test3[letter] = letter;
		});
		if (Object.keys(Object.assign({}, test3)).join('') !==
				'abcdefghijklmnopqrst') {
			return false;
		}

		return true;
	} catch (err) {
		// We don't expect any of the above to throw, but better to be safe.
		return false;
	}
}

var objectAssign = shouldUseNative() ? Object.assign : function (target, source) {
	var from;
	var to = toObject(target);
	var symbols;

	for (var s = 1; s < arguments.length; s++) {
		from = Object(arguments[s]);

		for (var key in from) {
			if (hasOwnProperty.call(from, key)) {
				to[key] = from[key];
			}
		}

		if (getOwnPropertySymbols) {
			symbols = getOwnPropertySymbols(from);
			for (var i = 0; i < symbols.length; i++) {
				if (propIsEnumerable.call(from, symbols[i])) {
					to[symbols[i]] = from[symbols[i]];
				}
			}
		}
	}

	return to;
};

/**
 * Copyright (c) 2013-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

var ReactPropTypesSecret = 'SECRET_DO_NOT_PASS_THIS_OR_YOU_WILL_BE_FIRED';

var ReactPropTypesSecret_1 = ReactPropTypesSecret;

var printWarning = function() {};

if (process.env.NODE_ENV !== 'production') {
  var ReactPropTypesSecret$1 = ReactPropTypesSecret_1;
  var loggedTypeFailures = {};
  var has = Function.call.bind(Object.prototype.hasOwnProperty);

  printWarning = function(text) {
    var message = 'Warning: ' + text;
    if (typeof console !== 'undefined') {
      console.error(message);
    }
    try {
      // --- Welcome to debugging React ---
      // This error was thrown as a convenience so that you can use this stack
      // to find the callsite that caused this warning to fire.
      throw new Error(message);
    } catch (x) {}
  };
}

/**
 * Assert that the values match with the type specs.
 * Error messages are memorized and will only be shown once.
 *
 * @param {object} typeSpecs Map of name to a ReactPropType
 * @param {object} values Runtime values that need to be type-checked
 * @param {string} location e.g. "prop", "context", "child context"
 * @param {string} componentName Name of the component for error messages.
 * @param {?Function} getStack Returns the component stack.
 * @private
 */
function checkPropTypes(typeSpecs, values, location, componentName, getStack) {
  if (process.env.NODE_ENV !== 'production') {
    for (var typeSpecName in typeSpecs) {
      if (has(typeSpecs, typeSpecName)) {
        var error;
        // Prop type validation may throw. In case they do, we don't want to
        // fail the render phase where it didn't fail before. So we log it.
        // After these have been cleaned up, we'll let them throw.
        try {
          // This is intentionally an invariant that gets caught. It's the same
          // behavior as without this statement except with a better message.
          if (typeof typeSpecs[typeSpecName] !== 'function') {
            var err = Error(
              (componentName || 'React class') + ': ' + location + ' type `' + typeSpecName + '` is invalid; ' +
              'it must be a function, usually from the `prop-types` package, but received `' + typeof typeSpecs[typeSpecName] + '`.'
            );
            err.name = 'Invariant Violation';
            throw err;
          }
          error = typeSpecs[typeSpecName](values, typeSpecName, componentName, location, null, ReactPropTypesSecret$1);
        } catch (ex) {
          error = ex;
        }
        if (error && !(error instanceof Error)) {
          printWarning(
            (componentName || 'React class') + ': type specification of ' +
            location + ' `' + typeSpecName + '` is invalid; the type checker ' +
            'function must return `null` or an `Error` but returned a ' + typeof error + '. ' +
            'You may have forgotten to pass an argument to the type checker ' +
            'creator (arrayOf, instanceOf, objectOf, oneOf, oneOfType, and ' +
            'shape all require an argument).'
          );
        }
        if (error instanceof Error && !(error.message in loggedTypeFailures)) {
          // Only monitor this failure once because there tends to be a lot of the
          // same error.
          loggedTypeFailures[error.message] = true;

          var stack = getStack ? getStack() : '';

          printWarning(
            'Failed ' + location + ' type: ' + error.message + (stack != null ? stack : '')
          );
        }
      }
    }
  }
}

/**
 * Resets warning cache when testing.
 *
 * @private
 */
checkPropTypes.resetWarningCache = function() {
  if (process.env.NODE_ENV !== 'production') {
    loggedTypeFailures = {};
  }
};

var checkPropTypes_1 = checkPropTypes;

var has$1 = Function.call.bind(Object.prototype.hasOwnProperty);
var printWarning$1 = function() {};

if (process.env.NODE_ENV !== 'production') {
  printWarning$1 = function(text) {
    var message = 'Warning: ' + text;
    if (typeof console !== 'undefined') {
      console.error(message);
    }
    try {
      // --- Welcome to debugging React ---
      // This error was thrown as a convenience so that you can use this stack
      // to find the callsite that caused this warning to fire.
      throw new Error(message);
    } catch (x) {}
  };
}

function emptyFunctionThatReturnsNull() {
  return null;
}

var factoryWithTypeCheckers = function(isValidElement, throwOnDirectAccess) {
  /* global Symbol */
  var ITERATOR_SYMBOL = typeof Symbol === 'function' && Symbol.iterator;
  var FAUX_ITERATOR_SYMBOL = '@@iterator'; // Before Symbol spec.

  /**
   * Returns the iterator method function contained on the iterable object.
   *
   * Be sure to invoke the function with the iterable as context:
   *
   *     var iteratorFn = getIteratorFn(myIterable);
   *     if (iteratorFn) {
   *       var iterator = iteratorFn.call(myIterable);
   *       ...
   *     }
   *
   * @param {?object} maybeIterable
   * @return {?function}
   */
  function getIteratorFn(maybeIterable) {
    var iteratorFn = maybeIterable && (ITERATOR_SYMBOL && maybeIterable[ITERATOR_SYMBOL] || maybeIterable[FAUX_ITERATOR_SYMBOL]);
    if (typeof iteratorFn === 'function') {
      return iteratorFn;
    }
  }

  /**
   * Collection of methods that allow declaration and validation of props that are
   * supplied to React components. Example usage:
   *
   *   var Props = require('ReactPropTypes');
   *   var MyArticle = React.createClass({
   *     propTypes: {
   *       // An optional string prop named "description".
   *       description: Props.string,
   *
   *       // A required enum prop named "category".
   *       category: Props.oneOf(['News','Photos']).isRequired,
   *
   *       // A prop named "dialog" that requires an instance of Dialog.
   *       dialog: Props.instanceOf(Dialog).isRequired
   *     },
   *     render: function() { ... }
   *   });
   *
   * A more formal specification of how these methods are used:
   *
   *   type := array|bool|func|object|number|string|oneOf([...])|instanceOf(...)
   *   decl := ReactPropTypes.{type}(.isRequired)?
   *
   * Each and every declaration produces a function with the same signature. This
   * allows the creation of custom validation functions. For example:
   *
   *  var MyLink = React.createClass({
   *    propTypes: {
   *      // An optional string or URI prop named "href".
   *      href: function(props, propName, componentName) {
   *        var propValue = props[propName];
   *        if (propValue != null && typeof propValue !== 'string' &&
   *            !(propValue instanceof URI)) {
   *          return new Error(
   *            'Expected a string or an URI for ' + propName + ' in ' +
   *            componentName
   *          );
   *        }
   *      }
   *    },
   *    render: function() {...}
   *  });
   *
   * @internal
   */

  var ANONYMOUS = '<<anonymous>>';

  // Important!
  // Keep this list in sync with production version in `./factoryWithThrowingShims.js`.
  var ReactPropTypes = {
    array: createPrimitiveTypeChecker('array'),
    bool: createPrimitiveTypeChecker('boolean'),
    func: createPrimitiveTypeChecker('function'),
    number: createPrimitiveTypeChecker('number'),
    object: createPrimitiveTypeChecker('object'),
    string: createPrimitiveTypeChecker('string'),
    symbol: createPrimitiveTypeChecker('symbol'),

    any: createAnyTypeChecker(),
    arrayOf: createArrayOfTypeChecker,
    element: createElementTypeChecker(),
    elementType: createElementTypeTypeChecker(),
    instanceOf: createInstanceTypeChecker,
    node: createNodeChecker(),
    objectOf: createObjectOfTypeChecker,
    oneOf: createEnumTypeChecker,
    oneOfType: createUnionTypeChecker,
    shape: createShapeTypeChecker,
    exact: createStrictShapeTypeChecker,
  };

  /**
   * inlined Object.is polyfill to avoid requiring consumers ship their own
   * https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Object/is
   */
  /*eslint-disable no-self-compare*/
  function is(x, y) {
    // SameValue algorithm
    if (x === y) {
      // Steps 1-5, 7-10
      // Steps 6.b-6.e: +0 != -0
      return x !== 0 || 1 / x === 1 / y;
    } else {
      // Step 6.a: NaN == NaN
      return x !== x && y !== y;
    }
  }
  /*eslint-enable no-self-compare*/

  /**
   * We use an Error-like object for backward compatibility as people may call
   * PropTypes directly and inspect their output. However, we don't use real
   * Errors anymore. We don't inspect their stack anyway, and creating them
   * is prohibitively expensive if they are created too often, such as what
   * happens in oneOfType() for any type before the one that matched.
   */
  function PropTypeError(message) {
    this.message = message;
    this.stack = '';
  }
  // Make `instanceof Error` still work for returned errors.
  PropTypeError.prototype = Error.prototype;

  function createChainableTypeChecker(validate) {
    if (process.env.NODE_ENV !== 'production') {
      var manualPropTypeCallCache = {};
      var manualPropTypeWarningCount = 0;
    }
    function checkType(isRequired, props, propName, componentName, location, propFullName, secret) {
      componentName = componentName || ANONYMOUS;
      propFullName = propFullName || propName;

      if (secret !== ReactPropTypesSecret_1) {
        if (throwOnDirectAccess) {
          // New behavior only for users of `prop-types` package
          var err = new Error(
            'Calling PropTypes validators directly is not supported by the `prop-types` package. ' +
            'Use `PropTypes.checkPropTypes()` to call them. ' +
            'Read more at http://fb.me/use-check-prop-types'
          );
          err.name = 'Invariant Violation';
          throw err;
        } else if (process.env.NODE_ENV !== 'production' && typeof console !== 'undefined') {
          // Old behavior for people using React.PropTypes
          var cacheKey = componentName + ':' + propName;
          if (
            !manualPropTypeCallCache[cacheKey] &&
            // Avoid spamming the console because they are often not actionable except for lib authors
            manualPropTypeWarningCount < 3
          ) {
            printWarning$1(
              'You are manually calling a React.PropTypes validation ' +
              'function for the `' + propFullName + '` prop on `' + componentName  + '`. This is deprecated ' +
              'and will throw in the standalone `prop-types` package. ' +
              'You may be seeing this warning due to a third-party PropTypes ' +
              'library. See https://fb.me/react-warning-dont-call-proptypes ' + 'for details.'
            );
            manualPropTypeCallCache[cacheKey] = true;
            manualPropTypeWarningCount++;
          }
        }
      }
      if (props[propName] == null) {
        if (isRequired) {
          if (props[propName] === null) {
            return new PropTypeError('The ' + location + ' `' + propFullName + '` is marked as required ' + ('in `' + componentName + '`, but its value is `null`.'));
          }
          return new PropTypeError('The ' + location + ' `' + propFullName + '` is marked as required in ' + ('`' + componentName + '`, but its value is `undefined`.'));
        }
        return null;
      } else {
        return validate(props, propName, componentName, location, propFullName);
      }
    }

    var chainedCheckType = checkType.bind(null, false);
    chainedCheckType.isRequired = checkType.bind(null, true);

    return chainedCheckType;
  }

  function createPrimitiveTypeChecker(expectedType) {
    function validate(props, propName, componentName, location, propFullName, secret) {
      var propValue = props[propName];
      var propType = getPropType(propValue);
      if (propType !== expectedType) {
        // `propValue` being instance of, say, date/regexp, pass the 'object'
        // check, but we can offer a more precise error message here rather than
        // 'of type `object`'.
        var preciseType = getPreciseType(propValue);

        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + preciseType + '` supplied to `' + componentName + '`, expected ') + ('`' + expectedType + '`.'));
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createAnyTypeChecker() {
    return createChainableTypeChecker(emptyFunctionThatReturnsNull);
  }

  function createArrayOfTypeChecker(typeChecker) {
    function validate(props, propName, componentName, location, propFullName) {
      if (typeof typeChecker !== 'function') {
        return new PropTypeError('Property `' + propFullName + '` of component `' + componentName + '` has invalid PropType notation inside arrayOf.');
      }
      var propValue = props[propName];
      if (!Array.isArray(propValue)) {
        var propType = getPropType(propValue);
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected an array.'));
      }
      for (var i = 0; i < propValue.length; i++) {
        var error = typeChecker(propValue, i, componentName, location, propFullName + '[' + i + ']', ReactPropTypesSecret_1);
        if (error instanceof Error) {
          return error;
        }
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createElementTypeChecker() {
    function validate(props, propName, componentName, location, propFullName) {
      var propValue = props[propName];
      if (!isValidElement(propValue)) {
        var propType = getPropType(propValue);
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected a single ReactElement.'));
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createElementTypeTypeChecker() {
    function validate(props, propName, componentName, location, propFullName) {
      var propValue = props[propName];
      if (!reactIs.isValidElementType(propValue)) {
        var propType = getPropType(propValue);
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected a single ReactElement type.'));
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createInstanceTypeChecker(expectedClass) {
    function validate(props, propName, componentName, location, propFullName) {
      if (!(props[propName] instanceof expectedClass)) {
        var expectedClassName = expectedClass.name || ANONYMOUS;
        var actualClassName = getClassName(props[propName]);
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + actualClassName + '` supplied to `' + componentName + '`, expected ') + ('instance of `' + expectedClassName + '`.'));
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createEnumTypeChecker(expectedValues) {
    if (!Array.isArray(expectedValues)) {
      if (process.env.NODE_ENV !== 'production') {
        if (arguments.length > 1) {
          printWarning$1(
            'Invalid arguments supplied to oneOf, expected an array, got ' + arguments.length + ' arguments. ' +
            'A common mistake is to write oneOf(x, y, z) instead of oneOf([x, y, z]).'
          );
        } else {
          printWarning$1('Invalid argument supplied to oneOf, expected an array.');
        }
      }
      return emptyFunctionThatReturnsNull;
    }

    function validate(props, propName, componentName, location, propFullName) {
      var propValue = props[propName];
      for (var i = 0; i < expectedValues.length; i++) {
        if (is(propValue, expectedValues[i])) {
          return null;
        }
      }

      var valuesString = JSON.stringify(expectedValues, function replacer(key, value) {
        var type = getPreciseType(value);
        if (type === 'symbol') {
          return String(value);
        }
        return value;
      });
      return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of value `' + String(propValue) + '` ' + ('supplied to `' + componentName + '`, expected one of ' + valuesString + '.'));
    }
    return createChainableTypeChecker(validate);
  }

  function createObjectOfTypeChecker(typeChecker) {
    function validate(props, propName, componentName, location, propFullName) {
      if (typeof typeChecker !== 'function') {
        return new PropTypeError('Property `' + propFullName + '` of component `' + componentName + '` has invalid PropType notation inside objectOf.');
      }
      var propValue = props[propName];
      var propType = getPropType(propValue);
      if (propType !== 'object') {
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type ' + ('`' + propType + '` supplied to `' + componentName + '`, expected an object.'));
      }
      for (var key in propValue) {
        if (has$1(propValue, key)) {
          var error = typeChecker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret_1);
          if (error instanceof Error) {
            return error;
          }
        }
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createUnionTypeChecker(arrayOfTypeCheckers) {
    if (!Array.isArray(arrayOfTypeCheckers)) {
      process.env.NODE_ENV !== 'production' ? printWarning$1('Invalid argument supplied to oneOfType, expected an instance of array.') : void 0;
      return emptyFunctionThatReturnsNull;
    }

    for (var i = 0; i < arrayOfTypeCheckers.length; i++) {
      var checker = arrayOfTypeCheckers[i];
      if (typeof checker !== 'function') {
        printWarning$1(
          'Invalid argument supplied to oneOfType. Expected an array of check functions, but ' +
          'received ' + getPostfixForTypeWarning(checker) + ' at index ' + i + '.'
        );
        return emptyFunctionThatReturnsNull;
      }
    }

    function validate(props, propName, componentName, location, propFullName) {
      for (var i = 0; i < arrayOfTypeCheckers.length; i++) {
        var checker = arrayOfTypeCheckers[i];
        if (checker(props, propName, componentName, location, propFullName, ReactPropTypesSecret_1) == null) {
          return null;
        }
      }

      return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` supplied to ' + ('`' + componentName + '`.'));
    }
    return createChainableTypeChecker(validate);
  }

  function createNodeChecker() {
    function validate(props, propName, componentName, location, propFullName) {
      if (!isNode(props[propName])) {
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` supplied to ' + ('`' + componentName + '`, expected a ReactNode.'));
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createShapeTypeChecker(shapeTypes) {
    function validate(props, propName, componentName, location, propFullName) {
      var propValue = props[propName];
      var propType = getPropType(propValue);
      if (propType !== 'object') {
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type `' + propType + '` ' + ('supplied to `' + componentName + '`, expected `object`.'));
      }
      for (var key in shapeTypes) {
        var checker = shapeTypes[key];
        if (!checker) {
          continue;
        }
        var error = checker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret_1);
        if (error) {
          return error;
        }
      }
      return null;
    }
    return createChainableTypeChecker(validate);
  }

  function createStrictShapeTypeChecker(shapeTypes) {
    function validate(props, propName, componentName, location, propFullName) {
      var propValue = props[propName];
      var propType = getPropType(propValue);
      if (propType !== 'object') {
        return new PropTypeError('Invalid ' + location + ' `' + propFullName + '` of type `' + propType + '` ' + ('supplied to `' + componentName + '`, expected `object`.'));
      }
      // We need to check all keys in case some are required but missing from
      // props.
      var allKeys = objectAssign({}, props[propName], shapeTypes);
      for (var key in allKeys) {
        var checker = shapeTypes[key];
        if (!checker) {
          return new PropTypeError(
            'Invalid ' + location + ' `' + propFullName + '` key `' + key + '` supplied to `' + componentName + '`.' +
            '\nBad object: ' + JSON.stringify(props[propName], null, '  ') +
            '\nValid keys: ' +  JSON.stringify(Object.keys(shapeTypes), null, '  ')
          );
        }
        var error = checker(propValue, key, componentName, location, propFullName + '.' + key, ReactPropTypesSecret_1);
        if (error) {
          return error;
        }
      }
      return null;
    }

    return createChainableTypeChecker(validate);
  }

  function isNode(propValue) {
    switch (typeof propValue) {
      case 'number':
      case 'string':
      case 'undefined':
        return true;
      case 'boolean':
        return !propValue;
      case 'object':
        if (Array.isArray(propValue)) {
          return propValue.every(isNode);
        }
        if (propValue === null || isValidElement(propValue)) {
          return true;
        }

        var iteratorFn = getIteratorFn(propValue);
        if (iteratorFn) {
          var iterator = iteratorFn.call(propValue);
          var step;
          if (iteratorFn !== propValue.entries) {
            while (!(step = iterator.next()).done) {
              if (!isNode(step.value)) {
                return false;
              }
            }
          } else {
            // Iterator will provide entry [k,v] tuples rather than values.
            while (!(step = iterator.next()).done) {
              var entry = step.value;
              if (entry) {
                if (!isNode(entry[1])) {
                  return false;
                }
              }
            }
          }
        } else {
          return false;
        }

        return true;
      default:
        return false;
    }
  }

  function isSymbol(propType, propValue) {
    // Native Symbol.
    if (propType === 'symbol') {
      return true;
    }

    // falsy value can't be a Symbol
    if (!propValue) {
      return false;
    }

    // 19.4.3.5 Symbol.prototype[@@toStringTag] === 'Symbol'
    if (propValue['@@toStringTag'] === 'Symbol') {
      return true;
    }

    // Fallback for non-spec compliant Symbols which are polyfilled.
    if (typeof Symbol === 'function' && propValue instanceof Symbol) {
      return true;
    }

    return false;
  }

  // Equivalent of `typeof` but with special handling for array and regexp.
  function getPropType(propValue) {
    var propType = typeof propValue;
    if (Array.isArray(propValue)) {
      return 'array';
    }
    if (propValue instanceof RegExp) {
      // Old webkits (at least until Android 4.0) return 'function' rather than
      // 'object' for typeof a RegExp. We'll normalize this here so that /bla/
      // passes PropTypes.object.
      return 'object';
    }
    if (isSymbol(propType, propValue)) {
      return 'symbol';
    }
    return propType;
  }

  // This handles more types than `getPropType`. Only used for error messages.
  // See `createPrimitiveTypeChecker`.
  function getPreciseType(propValue) {
    if (typeof propValue === 'undefined' || propValue === null) {
      return '' + propValue;
    }
    var propType = getPropType(propValue);
    if (propType === 'object') {
      if (propValue instanceof Date) {
        return 'date';
      } else if (propValue instanceof RegExp) {
        return 'regexp';
      }
    }
    return propType;
  }

  // Returns a string that is postfixed to a warning about an invalid type.
  // For example, "undefined" or "of type array"
  function getPostfixForTypeWarning(value) {
    var type = getPreciseType(value);
    switch (type) {
      case 'array':
      case 'object':
        return 'an ' + type;
      case 'boolean':
      case 'date':
      case 'regexp':
        return 'a ' + type;
      default:
        return type;
    }
  }

  // Returns class name of the object, if any.
  function getClassName(propValue) {
    if (!propValue.constructor || !propValue.constructor.name) {
      return ANONYMOUS;
    }
    return propValue.constructor.name;
  }

  ReactPropTypes.checkPropTypes = checkPropTypes_1;
  ReactPropTypes.resetWarningCache = checkPropTypes_1.resetWarningCache;
  ReactPropTypes.PropTypes = ReactPropTypes;

  return ReactPropTypes;
};

function emptyFunction() {}
function emptyFunctionWithReset() {}
emptyFunctionWithReset.resetWarningCache = emptyFunction;

var factoryWithThrowingShims = function() {
  function shim(props, propName, componentName, location, propFullName, secret) {
    if (secret === ReactPropTypesSecret_1) {
      // It is still safe when called from React.
      return;
    }
    var err = new Error(
      'Calling PropTypes validators directly is not supported by the `prop-types` package. ' +
      'Use PropTypes.checkPropTypes() to call them. ' +
      'Read more at http://fb.me/use-check-prop-types'
    );
    err.name = 'Invariant Violation';
    throw err;
  }  shim.isRequired = shim;
  function getShim() {
    return shim;
  }  // Important!
  // Keep this list in sync with production version in `./factoryWithTypeCheckers.js`.
  var ReactPropTypes = {
    array: shim,
    bool: shim,
    func: shim,
    number: shim,
    object: shim,
    string: shim,
    symbol: shim,

    any: shim,
    arrayOf: getShim,
    element: shim,
    elementType: shim,
    instanceOf: getShim,
    node: shim,
    objectOf: getShim,
    oneOf: getShim,
    oneOfType: getShim,
    shape: getShim,
    exact: getShim,

    checkPropTypes: emptyFunctionWithReset,
    resetWarningCache: emptyFunction
  };

  ReactPropTypes.PropTypes = ReactPropTypes;

  return ReactPropTypes;
};

var propTypes = createCommonjsModule(function (module) {
/**
 * Copyright (c) 2013-present, Facebook, Inc.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 */

if (process.env.NODE_ENV !== 'production') {
  var ReactIs = reactIs;

  // By explicitly using `prop-types` you are opting into new development behavior.
  // http://fb.me/prop-types-in-prod
  var throwOnDirectAccess = true;
  module.exports = factoryWithTypeCheckers(ReactIs.isElement, throwOnDirectAccess);
} else {
  // By explicitly using `prop-types` you are opting into new production behavior.
  // http://fb.me/prop-types-in-prod
  module.exports = factoryWithThrowingShims();
}
});

function useEventListener(eventName, handler, element) {
  if (element === void 0) {
    element = window;
  }

  var savedHandler = useRef();
  useEffect(function () {
    savedHandler.current = handler;
  }, [handler]);
  useEffect(function () {
    var isSupported = element && element.addEventListener;
    if (!isSupported) return;

    var eventListener = function eventListener(event) {
      return savedHandler.current(event);
    };

    element.addEventListener(eventName, eventListener);
    return function () {
      element.removeEventListener(eventName, eventListener);
    };
  }, [eventName, element]);
}

var styles = {"modal-pane":"_3WGgp","modal-content":"_315cL","modal-header":"_19ZDP","modal-body":"_3-4yw","bold":"_o2-tb","align-center":"_2t0S1","button-primary":"_1szgW","button-secondary":"_3t0Wm","show-modal":"_r3Qnu"};

var Modal = function Modal(_ref) {
  var intro = _ref.intro,
      index = _ref.index,
      setIndex = _ref.setIndex,
      className = _ref.className,
      maxLength = _ref.maxLength,
      isVisible = _ref.isVisible,
      onClose = _ref.onClose,
      props = _objectWithoutPropertiesLoose(_ref, ["intro", "index", "setIndex", "className", "maxLength", "isVisible", "onClose"]);

  var isInRange = function isInRange(x) {
    var min = 0;
    var max = maxLength - 1;
    return x >= min && x <= max;
  };

  var prev = function prev() {
    if (isInRange(index - 1)) {
      setIndex(index - 1);
    } else {
      onCloseAndReset();
    }
  };

  var next = function next() {
    if (isInRange(index + 1)) {
      setIndex(index + 1);
    } else {
      onCloseAndReset();
    }
  };

  var onCloseAndReset = function onCloseAndReset() {
    onClose();
    setIndex(0);
  };

  var overlays = document.getElementsByTagName('section');

  for (var _iterator = _createForOfIteratorHelperLoose(overlays), _step; !(_step = _iterator()).done;) {
    var overlay = _step.value;
    document.body.removeChild(overlay);
  }

  var checkKey = useCallback(function (e) {
    e = e || window.event;
    var _e = e,
        keyCode = _e.keyCode;

    if ([38, 39].includes(keyCode)) {
      next();
    } else if ([40, 37].includes(keyCode)) {
      prev();
    } else if (keyCode === 27) {
      onCloseAndReset();
    }
  });
  useEventListener('keydown', checkKey);
  return /*#__PURE__*/React__default.createElement("div", {
    className: className + " " + styles['modal-pane'] + " " + (isVisible && styles['show-modal'])
  }, /*#__PURE__*/React__default.createElement("div", {
    className: "" + styles['modal-content']
  }, /*#__PURE__*/React__default.createElement("img", {
    src: "https://cdn4.iconfinder.com/data/icons/avatar-circle-1-1/72/6-512.png"
  }), /*#__PURE__*/React__default.createElement("div", {
    className: styles['modal-header'] + " " + styles['fixed-top']
  }, /*#__PURE__*/React__default.createElement("h4", null), /*#__PURE__*/React__default.createElement("p", {
    onClick: onClose
  }, "close")), /*#__PURE__*/React__default.createElement("div", {
    className: "" + styles['modal-body']
  }, props.children, intro ? /*#__PURE__*/React__default.createElement("div", {
    className: styles['align-center']
  }, /*#__PURE__*/React__default.createElement("button", {
    className: styles['button-primary'],
    onClick: next
  }, "Yes, show me"), /*#__PURE__*/React__default.createElement("button", {
    className: styles['button-secondary'],
    onClick: onCloseAndReset
  }, "Not right now")) : index === maxLength - 1 ? /*#__PURE__*/React__default.createElement("div", {
    className: styles['align-center']
  }, /*#__PURE__*/React__default.createElement("button", {
    className: styles['button-secondary'],
    onClick: prev
  }, "previous"), /*#__PURE__*/React__default.createElement("button", {
    className: styles['button-primary'],
    onClick: onCloseAndReset
  }, "End Tour")) : /*#__PURE__*/React__default.createElement("div", {
    className: styles['align-center']
  }, /*#__PURE__*/React__default.createElement("button", {
    className: styles['button-secondary'],
    onClick: prev
  }, "previous"), /*#__PURE__*/React__default.createElement("button", {
    className: styles['button-primary'],
    onClick: next
  }, "next")))));
};

Modal.propTypes = {
  intro: propTypes.bool.isRequired,
  index: propTypes.number.isRequired,
  setIndex: propTypes.func.isRequired,
  className: propTypes.string,
  maxLength: propTypes.number.isRequired,
  isVisible: propTypes.bool.isRequired,
  onClose: propTypes.func.isRequired
};
Modal.defaultProps = {
  isVisible: false
};

var styles$1 = {"container":"_ijPnU","tooltipContent":"_2hASn","fadeIn":"_3xW5u","sm":"_88Wrj","md":"_Ks2th","cancel":"_1RyPu","arrow":"_33nJ1","top":"_3QwLY","right":"_37Jt9","left":"_26cC8","center":"_1x_r7","bottom":"_Kl1rb","align-center":"_2Q31f","button-primary":"_1hnkw","button-secondary":"_2rcQQ","exclude":"_zIGqj","overlayZ":"_1WC86"};

var getElemDistance = function getElemDistance(elem) {
  var elementDimensions = elem && elem.getBoundingClientRect();

  var _ref = elementDimensions || [],
      width = _ref.width,
      height = _ref.height;

  var left = 0;
  var right = 0;
  var top = 0;
  var bottom = 0;

  if (elem.offsetParent) {
    do {
      left += elem.offsetLeft;
      top += elem.offsetTop;
      elem = elem.offsetParent;
    } while (elem);
  }

  right = left + width;
  bottom = top + height;
  left = left >= 0 ? left : 0;
  right = right >= 0 ? right : 0;
  top = top >= 0 ? top : 0;
  bottom = bottom >= 0 ? bottom : 0;
  return {
    left: left,
    right: right,
    top: top,
    bottom: bottom
  };
};

var CancelIcon = require("./cancel~JNochEUg.svg");

var Tooltip = function Tooltip(_ref) {
  var index = _ref.index,
      setIndex = _ref.setIndex,
      selectedData = _ref.selectedData,
      maxLength = _ref.maxLength,
      title = _ref.title,
      isVisible = _ref.isVisible,
      onClose = _ref.onClose;
  var nodeRef = useRef(null);
  var tooltipNodeRef = useRef(null);

  var _useState = useState(null),
      tooltipDimension = _useState[0],
      setTooltipDimension = _useState[1];

  var _useState2 = useState(null),
      elementDimensions = _useState2[0],
      setElementDimensions = _useState2[1];

  var _useState3 = useState([null, '']),
      tooltipStyles = _useState3[0],
      setTooltipStyles = _useState3[1];

  var _useState4 = useState(false),
      hasRemovedOverlay = _useState4[0],
      setHasRemovedOverlay = _useState4[1];

  useEffect(function () {
    if (tooltipNodeRef.current && !tooltipDimension) {
      var _ref2 = tooltipNodeRef.current || [],
          offsetWidth = _ref2.offsetWidth,
          offsetHeight = _ref2.offsetHeight;

      setTooltipDimension({
        offsetWidth: offsetWidth,
        offsetHeight: offsetHeight
      });
    }
  }, [tooltipNodeRef]);

  var isInRange = function isInRange(x) {
    var min = 0;
    var max = maxLength - 1;
    return x >= min && x <= max;
  };

  var calculateDimensions = function calculateDimensions() {
    var dimensions = current && current.getBoundingClientRect();
    setElementDimensions(dimensions);
  };

  var prev = function prev() {
    if (current) {
      current.style.removeProperty('z-index');
    }

    if (isInRange(index - 1)) {
      setIndex(index - 1);
    } else {
      onCloseAndReset();
    }
  };

  var next = function next() {
    if (current) {
      current.style.removeProperty('z-index');
    }

    if (isInRange(index + 1)) {
      setIndex(index + 1);
    } else {
      onCloseAndReset();
    }
  };

  var onCloseAndReset = function onCloseAndReset() {
    removeOverlay();
    onClose();
    setIndex(0);
  };

  var removeOverlay = function removeOverlay() {
    var overlays = document.getElementsByTagName('section');

    for (var _iterator = _createForOfIteratorHelperLoose(overlays), _step; !(_step = _iterator()).done;) {
      var overlay = _step.value;
      document.body.removeChild(overlay);
    }

    if (current) {
      current.style.zIndex = 0;
    }
  };

  var computePosition = function computePosition() {
    var _ref3 = getElemDistance(current) || [],
        left = _ref3.left,
        right = _ref3.right,
        bottom = _ref3.bottom,
        top = _ref3.top;

    var _document$body = document.body,
        bodyScrollWidth = _document$body.scrollWidth,
        bodyScrollHeight = _document$body.scrollHeight;

    var _ref4 = tooltipDimension || [],
        tooltipWidth = _ref4.offsetWidth,
        tooltipHeight = _ref4.offsetHeight;

    var position;
    var cond1 = bodyScrollWidth < right + tooltipWidth;
    var cond2 = bodyScrollHeight < bottom + tooltipHeight;
    var cond3 = left < tooltipWidth;
    var cond4 = top < tooltipHeight;
    console.log(cond1, cond2, cond3, cond4);

    if (!cond2) {
      position = 'bottom';
    } else if (cond3 && !cond1 || !cond1) {
      position = 'right';
    } else if (cond1 && !cond3) {
      position = 'left';
    } else if (cond2 && !cond4) {
      position = 'top';
    } else if (cond1 && !cond2 && !cond3 && !cond4) {
      position = 'center';
    } else {
      position = 'center';
    }

    return position;
  };

  var generateTooltipStyle = function generateTooltipStyle(elementDimensions) {
    var _ref5 = elementDimensions || [],
        width = _ref5.width,
        height = _ref5.height;

    var _ref6 = getElemDistance(current) || [],
        top = _ref6.top,
        left = _ref6.left;

    var position = computePosition();
    return [{
      position: 'absolute',
      background: 'transparent',
      left: left + "px",
      width: width + "px",
      height: height + "px",
      top: top + "px",
      opacity: 1
    }, position];
  };

  var isInViewport = function isInViewport(element) {
    var rect = element.getBoundingClientRect();
    return rect.top >= 0 && rect.left >= 0 && rect.bottom <= (window.innerHeight || document.documentElement.clientHeight) && rect.right <= (window.innerWidth || document.documentElement.clientWidth);
  };

  var scrollToRef = function scrollToRef(current) {
    var _getElemDistance = getElemDistance(current),
        elemTop = _getElemDistance.top;

    var _ref7 = tooltipNodeRef.current.getBoundingClientRect() || [],
        height = _ref7.height;

    var tooltipTop = parseInt(elemTop - height);

    if (!isInViewport(current)) {
      window.scrollTo(0, tooltipTop);
    }
  };

  var current = selectedData.ref.current;
  var reCalculateDimensions = useCallback(function () {
    var dimensions = current && current.getBoundingClientRect();
    setElementDimensions(dimensions);
  });
  useEffect(function () {
    var body = document.body;
    var html = document.documentElement;
    var fullDocumentHeight = Math.max(body.scrollHeight, body.offsetHeight, html.clientHeight, html.scrollHeight, html.offsetHeight);

    if (isInRange(index) && current) {
      current.style.zIndex = 999;
      var existingOverlays = document.getElementsByTagName('section');
      var overlay;

      if (existingOverlays.length === 0 && !hasRemovedOverlay) {
        overlay = document.createElement('section');
        overlay.style.overflow = 'scroll';
        overlay.style.width = document.body.scrollWidth + 'px';
        overlay.style.height = fullDocumentHeight + 'px';
        document.body.prepend(overlay);
      }

      calculateDimensions();
    }
  }, [index]);
  var checkKey = useCallback(function (e) {
    e = e || window.event;
    var _e = e,
        keyCode = _e.keyCode;

    if ([38, 39].includes(keyCode)) {
      next();
    } else if ([40, 37].includes(keyCode)) {
      prev();
    } else if (keyCode === 27) {
      removeOverlay();
      setHasRemovedOverlay(true);
      onCloseAndReset();
    }
  });
  useEventListener('keydown', checkKey);
  useEventListener('resize', reCalculateDimensions);
  useEffect(function () {
    var _ref8 = elementDimensions ? generateTooltipStyle(elementDimensions) : [],
        style = _ref8[0],
        tooltipPosition = _ref8[1];

    setTooltipStyles([style, tooltipPosition]);
    scrollToRef(current);
  }, [elementDimensions]);
  var style = tooltipStyles[0],
      tooltipPosition = tooltipStyles[1];
  return /*#__PURE__*/React__default.createElement("div", {
    className: styles$1.container,
    "data-testid": "tooltip",
    ref: nodeRef,
    style: style
  }, /*#__PURE__*/React__default.createElement("div", {
    "data-testid": "tooltip-placeholder"
  }), isVisible && /*#__PURE__*/React__default.createElement("div", {
    ref: tooltipNodeRef,
    className: styles$1.tooltipContent + " " + styles$1[tooltipPosition],
    "data-testid": "tooltip-content"
  }, /*#__PURE__*/React__default.createElement("div", {
    className: styles$1.cancel
  }, /*#__PURE__*/React__default.createElement("img", {
    src: CancelIcon,
    alt: "cancel",
    onClick: onClose
  })), /*#__PURE__*/React__default.createElement("span", {
    className: styles$1.arrow
  }), title, /*#__PURE__*/React__default.createElement("div", {
    className: styles$1['align-center']
  }, /*#__PURE__*/React__default.createElement("button", {
    className: styles$1['button-secondary'],
    onClick: prev
  }, "Prev"), /*#__PURE__*/React__default.createElement("button", {
    className: styles$1['button-primary'],
    onClick: next
  }, "Next"))));
};

Tooltip.propTypes = {
  index: propTypes.number.isRequired,
  setIndex: propTypes.func.isRequired,
  selectedData: propTypes.object.isRequired,
  maxLength: propTypes.number.isRequired,
  title: propTypes.object.isRequired,
  isVisible: propTypes.bool.isRequired,
  onClose: propTypes.func.isRequired
};

var styles$2 = {"container":"_3rS0E","bubble":"_3a-Cs","fadeIn":"_36Z1_","tooltipContent":"_T5Wmi","sm":"_1vMsj","md":"_2qFcO","arrow":"_9Ojvx","top":"_342p1","right":"_38hT1","left":"_2wYWi","center":"_1OsvD","bottom":"_aTtZw","align-center":"_2R6VH","button-primary":"_1OmM8","button-secondary":"_3PCpd","exclude":"_37nu9","overlayZ":"_cqIW9","cancel":"_23QPx"};

var SpeechBubble = function SpeechBubble(_ref) {
  var index = _ref.index,
      setIndex = _ref.setIndex,
      maxLength = _ref.maxLength,
      title = _ref.title,
      isVisible = _ref.isVisible,
      onClose = _ref.onClose;
  var nodeRef = useRef(null);

  var _useState = useState(false),
      hasRemovedOverlay = _useState[0],
      setHasRemovedOverlay = _useState[1];

  var isInRange = function isInRange(x) {
    var min = 0;
    var max = maxLength - 1;
    return x >= min && x <= max;
  };

  var prev = function prev() {
    if (isInRange(index - 1)) {
      setIndex(index - 1);
    } else {
      onCloseAndReset();
    }
  };

  var next = function next() {
    if (isInRange(index + 1)) {
      setIndex(index + 1);
    } else {
      onCloseAndReset();
    }
  };

  var onCloseAndReset = function onCloseAndReset() {
    removeOverlay();
    onClose();
    setIndex(0);
  };

  var removeOverlay = function removeOverlay() {
    var overlays = document.getElementsByTagName('section');

    for (var _iterator = _createForOfIteratorHelperLoose(overlays), _step; !(_step = _iterator()).done;) {
      var overlay = _step.value;
      document.body.removeChild(overlay);
    }
  };

  useEffect(function () {
    if (isInRange(index)) {
      var existingOverlays = document.getElementsByTagName('section');
      var overlay;

      if (existingOverlays.length === 0 && !hasRemovedOverlay) {
        overlay = document.createElement('section');
        overlay.style.width = document.body.scrollWidth + 'px';
        overlay.style.height = document.body.scrollHeight + 'px';
        document.body.prepend(overlay);
      }

      var current = nodeRef && nodeRef.current;

      if (current) {
        scrollToRef(current);
      }
    }
  }, [index, nodeRef]);

  var isInViewport = function isInViewport(element) {
    var rect = element.getBoundingClientRect();
    return rect.top >= 0 && rect.left >= 0 && rect.bottom <= (window.innerHeight || document.documentElement.clientHeight) && rect.right <= (window.innerWidth || document.documentElement.clientWidth);
  };

  var scrollToRef = function scrollToRef(current) {
    var _getElemDistance = getElemDistance(current),
        top = _getElemDistance.top;

    var offsetHeight = current.offsetHeight;
    console.log(top, offsetHeight);

    if (!isInViewport(current)) {
      window.scrollTo(0, top);
    }
  };

  var checkKey = useCallback(function (e) {
    e = e || window.event;
    var _e = e,
        keyCode = _e.keyCode;

    if ([38, 39].includes(keyCode)) {
      console.log('Forward Keys');
      next();
    } else if ([40, 37].includes(keyCode)) {
      console.log('Back Keys');
      prev();
    } else if (keyCode === 27) {
      console.log('Cancel Keys');
      removeOverlay();
      setHasRemovedOverlay(true);
      onCloseAndReset();
    }
  });
  useEventListener('keydown', checkKey);
  return /*#__PURE__*/React__default.createElement("div", {
    className: styles$2.container,
    "data-testid": "tooltip",
    style: {
      width: '100px',
      height: '100px',
      position: 'fixed',
      bottom: 0,
      left: 0,
      zIndex: 999
    }
  }, /*#__PURE__*/React__default.createElement("div", {
    "data-testid": "tooltip-placeholder"
  }, /*#__PURE__*/React__default.createElement("img", {
    className: styles$2.bubble,
    style: {
      bottom: window.innerHeight + window.screenY + " px"
    },
    src: "https://cdn4.iconfinder.com/data/icons/avatar-circle-1-1/72/6-512.png"
  })), isVisible && /*#__PURE__*/React__default.createElement("div", {
    ref: nodeRef,
    className: styles$2.tooltipContent + " " + styles$2['top'],
    "data-testid": "tooltip-content"
  }, /*#__PURE__*/React__default.createElement("div", {
    className: styles$2.cancel
  }, /*#__PURE__*/React__default.createElement("img", {
    src: CancelIcon,
    alt: "cancel",
    onClick: onClose
  })), /*#__PURE__*/React__default.createElement("span", {
    className: styles$2.arrow
  }), title, /*#__PURE__*/React__default.createElement("div", {
    className: styles$2['align-center']
  }, /*#__PURE__*/React__default.createElement("button", {
    className: styles$2['button-secondary'],
    onClick: prev
  }, "Prev"), /*#__PURE__*/React__default.createElement("button", {
    className: styles$2['button-primary'],
    onClick: next
  }, "Next"))));
};

SpeechBubble.propTypes = {
  index: propTypes.number.isRequired,
  setIndex: propTypes.func.isRequired,
  maxLength: propTypes.number.isRequired,
  title: propTypes.object.isRequired,
  isVisible: propTypes.bool.isRequired,
  onClose: propTypes.func.isRequired
};

var UserOnboarding = function UserOnboarding(_ref) {
  var story = _ref.story,
      isVisible = _ref.isVisible,
      onClose = _ref.onClose,
      initialPosition = _ref.initialPosition;

  var _useState = useState(0),
      index = _useState[0],
      setIndex = _useState[1];

  var _useState2 = useState(false),
      visible = _useState2[0],
      setVisible = _useState2[1];

  useEffect(function () {
    setVisible(isVisible);

    if (!isVisible) {
      removeOverlay();
    }
  }, [isVisible]);
  useEffect(function () {
    if (initialPosition) {
      setIndex(initialPosition);
    }
  }, [initialPosition]);

  var removeOverlay = function removeOverlay() {
    var overlays = document.getElementsByTagName('section');

    for (var _iterator = _createForOfIteratorHelperLoose(overlays), _step; !(_step = _iterator()).done;) {
      var overlay = _step.value;
      document.body.removeChild(overlay);
    }
  };

  var selectedData = story[index];
  return visible ? /*#__PURE__*/React__default.createElement("div", null, selectedData.component === 'modal' ? /*#__PURE__*/React__default.createElement(Modal, {
    index: index,
    onClose: onClose,
    isVisible: visible,
    setIndex: setIndex,
    maxLength: story.length,
    className: selectedData.className,
    intro: selectedData.intro || false
  }, selectedData.children) : selectedData.component === 'tooltip' ? /*#__PURE__*/React__default.createElement(Tooltip, {
    index: index,
    selectedData: selectedData,
    setIndex: setIndex,
    maxLength: story.length,
    isVisible: visible,
    className: selectedData.className,
    onClose: onClose,
    title: selectedData.children
  }) : selectedData.component === 'speech-bubble' ? /*#__PURE__*/React__default.createElement(SpeechBubble, {
    index: index,
    setIndex: setIndex,
    maxLength: story.length,
    className: selectedData.className,
    isVisible: visible,
    onClose: onClose,
    title: selectedData.children
  }) : null) : null;
};

UserOnboarding.propTypes = {
  story: propTypes.array.isRequired,
  isVisible: propTypes.bool.isRequired,
  onClose: propTypes.func.isRequired,
  initialPosition: propTypes.number
};
UserOnboarding.defaultProps = {
  isVisible: false,
  initialPosition: 0
};

export default UserOnboarding;
//# sourceMappingURL=index.modern.js.map
